(define (domain btc)
  (:requirements :strips :equality :typing :conditional-effects :negative-preconditions :disjunctive-preconditions)
  (:types package bomb toilet)
  
  (:predicates
  
   (in ?p - package ?b - bomb)
   (defused ?b - bomb)
   (clog ?toilet - toilet)

)
  
(:action senseP
   :parameters (?p - package ?b - bomb)
   :precondition (true)
   :observables (in ?p ?b))
  (:action dunk	
   :parameters (?p - package 
                ?b - bomb 
                ?t - toilet)
   :precondition (not (clog ?t))
   :effect (and (when (in ?p ?b) (defused ?b))
                (clog ?t)))

 (:action flush	
  :parameters (?t - toilet)
  :precondition (true)          
  :effect (not (clog ?t))
))
(define (problem btc70)
(:domain btc)

(:objects b0 - bomb
p0 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 - package
	    t0  - toilet)
 (:initstates
(and
(true)
(not (defused b0))

(not (clog t0))

(exists (?p - package) (in ?p b0))
(forall (?p - package ?p2 - package) (when (and (not (= ?p ?p2)) (in ?p b0)) (not (in ?p2 b0))))

)
)

 (:goal (defused b0)))

 