(define (domain ringuo)
  (:requirements :strips :conditional-effects)
  (:predicates (inroom ?p) (closed ?r) (locked ?r))
  (:observables )

(:action move-up
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r1)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r0)))
))

(:action move-down
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r1)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r0)))
))

(:action close
   :effect (forall (?r) (when (inroom ?r) (closed ?r)))
    )

(:action lock
    :precondition (exists (?r) (and (inroom ?r) (closed ?r)))
    :effect (forall (?r) (when (inroom ?r) (locked ?r)))
    )
)

(define (problem ring02uo)
  (:domain ringuo)
  (:objects r0 r1 - room)
  (:initstates (and
	      (inroom r1)
              (forall (?r) (when (not (= ?r r1)) (not (inroom ?r))))
	      (forall (?r) (when (not (closed ?r)) (not (locked ?r))))
	   ))

  (:goal (forall (?r) (locked ?r)))
)
