(define (domain ringuo)
  (:requirements :strips :conditional-effects)
  (:predicates (inroom ?p) (closed ?r) (locked ?r))
  (:observables )

(:action move-up
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r1)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r2)))
  (when (inroom r2) (and (not (inroom r2)) (inroom r3)))
  (when (inroom r3) (and (not (inroom r3)) (inroom r4)))
  (when (inroom r4) (and (not (inroom r4)) (inroom r5)))
  (when (inroom r5) (and (not (inroom r5)) (inroom r6)))
  (when (inroom r6) (and (not (inroom r6)) (inroom r7)))
  (when (inroom r7) (and (not (inroom r7)) (inroom r8)))
  (when (inroom r8) (and (not (inroom r8)) (inroom r9)))
  (when (inroom r9) (and (not (inroom r9)) (inroom r0)))
))

(:action move-down
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r9)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r0)))
  (when (inroom r2) (and (not (inroom r2)) (inroom r1)))
  (when (inroom r3) (and (not (inroom r3)) (inroom r2)))
  (when (inroom r4) (and (not (inroom r4)) (inroom r3)))
  (when (inroom r5) (and (not (inroom r5)) (inroom r4)))
  (when (inroom r6) (and (not (inroom r6)) (inroom r5)))
  (when (inroom r7) (and (not (inroom r7)) (inroom r6)))
  (when (inroom r8) (and (not (inroom r8)) (inroom r7)))
  (when (inroom r9) (and (not (inroom r9)) (inroom r8)))
))

(:action close
   :effect (forall (?r) (when (inroom ?r) (closed ?r)))
    )

(:action lock
    :precondition (exists (?r) (and (inroom ?r) (closed ?r)))
    :effect (forall (?r) (when (inroom ?r) (locked ?r)))
    )
)

(define (problem ring10uo)
  (:domain ringuo)
  (:objects r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 - room)
  (:initstates (and
	      (inroom r1)
              (forall (?r) (when (not (= ?r r1)) (not (inroom ?r))))
	      (forall (?r) (when (not (closed ?r)) (not (locked ?r))))
	   ))

  (:goal (forall (?r) (locked ?r)))
)
