(define (domain ringuo)
  (:requirements :strips :conditional-effects)
  (:predicates (inroom ?p) (closed ?r) (locked ?r))
  (:observables )

(:action move-up
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r1)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r2)))
  (when (inroom r2) (and (not (inroom r2)) (inroom r3)))
  (when (inroom r3) (and (not (inroom r3)) (inroom r4)))
  (when (inroom r4) (and (not (inroom r4)) (inroom r5)))
  (when (inroom r5) (and (not (inroom r5)) (inroom r6)))
  (when (inroom r6) (and (not (inroom r6)) (inroom r7)))
  (when (inroom r7) (and (not (inroom r7)) (inroom r8)))
  (when (inroom r8) (and (not (inroom r8)) (inroom r9)))
  (when (inroom r9) (and (not (inroom r9)) (inroom r10)))
  (when (inroom r10) (and (not (inroom r10)) (inroom r11)))
  (when (inroom r11) (and (not (inroom r11)) (inroom r12)))
  (when (inroom r12) (and (not (inroom r12)) (inroom r13)))
  (when (inroom r13) (and (not (inroom r13)) (inroom r14)))
  (when (inroom r14) (and (not (inroom r14)) (inroom r15)))
  (when (inroom r15) (and (not (inroom r15)) (inroom r16)))
  (when (inroom r16) (and (not (inroom r16)) (inroom r17)))
  (when (inroom r17) (and (not (inroom r17)) (inroom r0)))
))

(:action move-down
  :effect (and
  (when (inroom r0) (and (not (inroom r0)) (inroom r17)))
  (when (inroom r1) (and (not (inroom r1)) (inroom r0)))
  (when (inroom r2) (and (not (inroom r2)) (inroom r1)))
  (when (inroom r3) (and (not (inroom r3)) (inroom r2)))
  (when (inroom r4) (and (not (inroom r4)) (inroom r3)))
  (when (inroom r5) (and (not (inroom r5)) (inroom r4)))
  (when (inroom r6) (and (not (inroom r6)) (inroom r5)))
  (when (inroom r7) (and (not (inroom r7)) (inroom r6)))
  (when (inroom r8) (and (not (inroom r8)) (inroom r7)))
  (when (inroom r9) (and (not (inroom r9)) (inroom r8)))
  (when (inroom r10) (and (not (inroom r10)) (inroom r9)))
  (when (inroom r11) (and (not (inroom r11)) (inroom r10)))
  (when (inroom r12) (and (not (inroom r12)) (inroom r11)))
  (when (inroom r13) (and (not (inroom r13)) (inroom r12)))
  (when (inroom r14) (and (not (inroom r14)) (inroom r13)))
  (when (inroom r15) (and (not (inroom r15)) (inroom r14)))
  (when (inroom r16) (and (not (inroom r16)) (inroom r15)))
  (when (inroom r17) (and (not (inroom r17)) (inroom r16)))
))

(:action close
   :effect (forall (?r) (when (inroom ?r) (closed ?r)))
    )

(:action lock
    :precondition (exists (?r) (and (inroom ?r) (closed ?r)))
    :effect (forall (?r) (when (inroom ?r) (locked ?r)))
    )
)

(define (problem ring18uo)
  (:domain ringuo)
  (:objects r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 r15 r16 r17 - room)
  (:initstates (and
	      (inroom r1)
              (forall (?r) (when (not (= ?r r1)) (not (inroom ?r))))
	      (forall (?r) (when (not (closed ?r)) (not (locked ?r))))
	   ))

  (:goal (forall (?r) (locked ?r)))
)
