(define (domain ring)
 (:predicates 
 (position ?x)
    (closed ?x) 
               (locked ?x)
          (open ?x) )
(:action move-up
                   :parameters ()
                   :precondition ()
                   :effect (and (when (and (position pos0) (not (position pos1)) (not (position pos2)) )
  (and (position pos1) (not (position pos0)) (not (position pos2)) ))
 (when (and (position pos1) (not (position pos0)) (not (position pos2)) )
  (and (position pos2) (not (position pos0)) (not (position pos1)) ))
 (when (and (position pos2) (not (position pos0)) (not (position pos1)) )
  (and (position pos0) (not (position pos1)) (not (position pos2)) ))
))
(:action move-down
                   :parameters ()
                   :precondition ()
                   :effect (and (when (and (position pos0) (not (position pos1)) (not (position pos2)) )
  (and (position pos2) (not (position pos0)) (not (position pos1)) ))
 (when (and (position pos1) (not (position pos0)) (not (position pos2)) )
  (and (position pos0) (not (position pos1)) (not (position pos2)) ))
 (when (and (position pos2) (not (position pos0)) (not (position pos1)) )
  (and (position pos1) (not (position pos0)) (not (position pos2)) ))
))
(:action lock
                   :parameters ()
                   :precondition ()
                   :effect (and (when (and (position pos0) (not (open win0)) (closed win0)(not (position pos1)) (not (position pos2)) )
  (and (locked win0) (not (closed win0))))
 (when (and (position pos1) (not (open win1)) (closed win1)(not (position pos0)) (not (position pos2)) )
  (and (locked win1) (not (closed win1))))
 (when (and (position pos2) (not (open win2)) (closed win2)(not (position pos0)) (not (position pos1)) )
  (and (locked win2) (not (closed win2))))
))
(:action close
                   :parameters ()
                   :precondition ()
                   :effect (and (when (and (position pos0) (open win0)(not (position pos1)) (not (position pos2)) )
  (and (closed win0) (not (open win0))))
 (when (and (position pos1) (open win1)(not (position pos0)) (not (position pos2)) )
  (and (closed win1) (not (open win1))))
 (when (and (position pos2) (open win2)(not (position pos0)) (not (position pos1)) )
  (and (closed win2) (not (open win2))))
))


))
(define (problem ring3)
(:domain ring)
(:requirements :strips :equality :typing :conditional-effects :disjunctive-preconditions)
(:objects win0 win1 win2 pos0 pos1 pos2 )
 (:init 
 
(oneof (position pos0)
(position pos1)
(position pos2)
)
(oneof (open win0)
 (closed win0)
 (locked win0))
(oneof (open win1)
 (closed win1)
 (locked win1))
(oneof (open win2)
 (closed win2)
 (locked win2))
 )
   (:goal (and 

(locked win0)
(locked win1)
(locked win2)
)))
