(define (domain bts)
  (:model (:dynamics :deterministic) (:feedback :partial))
  (:types PACKAGE BOMB TOILET)
  (:functions (bomb PACKAGE BOMB)
              (in BOMB PACKAGE)
  )
  (:predicates (armed BOMB)

               (explosive_odor PACKAGE)
  )
  (:objects nil - BOMB t - TOILET)

  (:ramification ram1
    :parameters ?p - PACKAGE
                ?b - BOMB
    :effect (:when (= (in ?b) ?p) (:set (bomb ?p) ?b))
            (:when (:not (= (in ?b) ?p)) (:set (bomb ?p) nil))
  )

  (:ramification ram2
     :parameters ?p - PACKAGE
                 ?b - BOMB
     :effect (:when (= (in ?b) ?p) 
                    (:set (explosive_odor ?p) true))
             (:when (:not (= (in ?b) ?p))
                    (:set (explosive_odor ?p) false))
  )

  (:action dunk
    :parameters ?p - PACKAGE
    :effect (:set (armed (bomb ?p)) false)
            
  )


  (:action sniff
     :parameters ?p - PACKAGE
     :observation (explosive_odor ?p)
  )
)


(define (problem p2)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 })
         (:set (armed b) true)
         (:set (armed nil) false))
  (:goal (:not (armed b))))

(define (problem p4)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 p3 p4 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 p3 p4 })
         (:set (armed b) true)
         (:set (armed nil) false)
         )
  (:goal (:not (armed b))))

(define (problem p6)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 p3 p4 p5 p6 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 p3 p4 p5 p6 })
         (:set (armed b) true)
         (:set (armed nil) false))
         
  (:goal (:not (armed b))))

(define (problem p8)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 p3 p4 p5 p6 p7 p8 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 p3 p4 p5 p6 p7 p8 })
         (:set (armed b) true)
         (:set (armed nil) false))

  (:goal (:not (armed b))))

(define (problem p10)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 })
         (:set (armed b) true)
         (:set (armed nil) false)
         )
  (:goal (:not (armed b))))
(define (problem p20)
  (:domain bts)
  (:objects b - BOMB
            p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 - PACKAGE)
  (:init (:set (in b) :in { p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 })
         (:set (armed b) true)
         (:set (armed nil) false)
         )
  (:goal (:not (armed b))))


