(define (domain cube)
 (:types place)
 (:predicates 
 (x-pos ?pos - place)
 (y-pos ?pos - place ) 
 (z-pos ?pos - place)
 
  )

(:action up-x
                   :parameters ()

                   :effect (and 
                 (when (and (x-pos p0)) (and (not (x-pos p0)) (x-pos p1) (not (x-pos p2)) ))
                 (when (and (x-pos p1)) (and (not (x-pos p0)) (not (x-pos p1)) (x-pos p2) ))
		 (when (x-pos p2) (and (not (x-pos p0)) (not (x-pos p1)) (x-pos p2) ))
))
(:action down-x
                   :parameters ()

                   :effect (and (when (x-pos p0) (and (x-pos p0) (not (x-pos p1)) (not (x-pos p2)) ))
                    (when (and (x-pos p1)) (and (x-pos p0) (not (x-pos p1)) (not (x-pos p2)) ))
                    (when (and (x-pos p2)) (and (x-pos p1) (not (x-pos p0)) (not (x-pos p2)) ))
))
(:action up-y
                   :parameters ()
;;                   :precondition ()
                   :effect (and (when (y-pos p2) (and (y-pos p2)(not (y-pos p0)) (not (y-pos p1)) ))
                 (when (and (y-pos p0)) (and (y-pos p1) (not (y-pos p0)) (not (y-pos p2)) ))
                 (when (and (y-pos p1)) (and (y-pos p2) (not (y-pos p0)) (not (y-pos p1)) ))
))
(:action down-y
                   :parameters ()
;;                   :precondition ()
                   :effect (and (when (y-pos p0) (and (y-pos p0) (not (y-pos p1)) (not (y-pos p2)) ))
                    (when (and (y-pos p1)) (and (y-pos p0) (not (y-pos p1)) (not (y-pos p2)) ))
                    (when (and (y-pos p2)) (and (y-pos p1) (not (y-pos p0)) (not (y-pos p2)) ))
))
(:action up-z
                   :parameters ()
;;                   :precondition ()
                   :effect (and (when (z-pos p2) (and (z-pos p2)(not (z-pos p0)) (not (z-pos p1)) ))
                 (when (and (z-pos p0)) (and (z-pos p1) (not (z-pos p0)) (not (z-pos p2)) ))
                 (when (and (z-pos p1)) (and (z-pos p2) (not (z-pos p0)) (not (z-pos p1)) ))
))

(:action down-z
                   :parameters ()
;                   :precondition ()
                   :effect (and (when (z-pos p0) (and (z-pos p0) (not (z-pos p1)) (not (z-pos p2)) ))
                                (when (z-pos p1) (and (z-pos p0) (not (z-pos p1)) (not (z-pos p2)) ))
                                (when (z-pos p2) (and (z-pos p1) (not (z-pos p0)) (not (z-pos p2)) ))
))

)


(define (problem cube3)
(:domain cube)

(:objects p0 p1 p2 - place )
 (:initstates
 (and

(exists (?p - place) (x-pos ?p))
(forall (?p - place ?p2 - place) (when (and (not (= ?p ?p2)) (x-pos ?p)) (not (x-pos ?p2))))
(exists (?p - place) (y-pos ?p))
(forall (?p - place ?p2 - place) (when (and (not (= ?p ?p2)) (y-pos ?p)) (not (y-pos ?p2))))
(exists (?p - place) (z-pos ?p))
(forall (?p - place ?p2 - place) (when (and (not (= ?p ?p2)) (z-pos ?p)) (not (z-pos ?p2))))
 ))

   (:goal (and (x-pos p1) (y-pos p1) (z-pos p1))))